SystemOrganization addCategory: #'Summer2010-STdoc'!
SystemOrganization addCategory: #'Summer2010-Morph'!

Object subclass: #MorphFire
	instanceVariableNames: 'tableau taille dissipation sleepTime'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Summer2010-Morph'!

!MorphFire methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 6/12/2010 16:53'!
delete
	(1 to: tableau size) do:
	[:i|
		(1 to: (tableau at: 1) size) do:
		[:j|
			((tableau at: i) at: j) delete.
		]
	
	]! !

!MorphFire methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/12/2010 19:07'!
dissipation
	^ dissipation! !

!MorphFire methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/12/2010 19:07'!
dissipation: anObject
	dissipation := anObject! !

!MorphFire methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 6/12/2010 20:13'!
drawFlame
| blockClosure clockProcess |

blockClosure :=
        [|awakeTime aDelay |
        awakeTime := self sleepTime.

        (tableau size) timesRepeat: 
							[self initColor.
							 self majColor.
                        aDelay := Delay forMilliseconds: awakeTime.
                        aDelay wait.]].
clockProcess := blockClosure newProcess.
clockProcess resume
	
	! !

!MorphFire methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 6/12/2010 19:40'!
drawFlame2
| blockClosure clockProcess |
self initColor .
blockClosure :=
        [|awakeTime aDelay |
        awakeTime := self sleepTime.

         (tableau size) timesRepeat: 
							[self majColor2.
                        aDelay := Delay forMilliseconds: awakeTime.
                        aDelay wait.]].
clockProcess := blockClosure newProcess.
clockProcess resume
	
	! !

!MorphFire methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 6/12/2010 19:55'!
drawFlames
| blockClosure clockProcess |
blockClosure :=
        [|awakeTime aDelay |
        awakeTime := 2 * self sleepTime.

        (tableau size) timesRepeat: 
							[self drawFlame2.
                        aDelay := Delay forMilliseconds: awakeTime.
                        aDelay wait.]].
clockProcess := blockClosure newProcess.
clockProcess resume
	
	! !

!MorphFire methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 6/13/2010 19:46'!
initColor
	|ligne median start|
	
	median := (((tableau at:1) size)*0.8)asInteger.
	start := ((tableau at:1) size) - median.
	
	Transcript show: 'start : ', start asString ; cr.
	Transcript show: 'median : ', median asString ; cr.
	
	ligne := tableau at: (tableau size).
	(1 to: start) do:
	[:i|
		(ligne at:i) color:(Color r:( Random new nextValue / 3000000000 -1) g:0 b:0);hide.	
	].
	(start to: median+start) do:
	[:i|
		(ligne at:i) color:(Color r: ( Random new nextValue / 1000000000 -1)g: 0 b:0);hide.	
	].
	(median+start to: ligne size) do:
	[:i|
		(ligne at:i) color:(Color r:( Random new nextValue / 3000000000 -1) g:0 b:0);hide.	
	].! !

!MorphFire methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 6/12/2010 20:00'!
initialize
	|nblignes nbcolonnes initX initY tempX tempY|

	nblignes := 100.
	nbcolonnes := 50.
	self taille: 2.
	
	initX := 50.
	initY := 50.
	self dissipation: 0.95.
	self sleepTime: 500.
	
	tableau := Array new: nblignes. "colone"
	(1 to: nblignes) do:
	[:i|
		tableau at: i put: (Array new: nbcolonnes).	 "ligne"
	].

	(1 to:  nblignes) do:
	[:col|
		(1 to: nbcolonnes) do:
		[:lig|
			tempX := (initX + (taille*lig)).
			tempY := (initY + (taille*col)).
			(tableau at: col) at: lig put: (Morph new bounds: ((tempX@tempY) corner: (tempX + taille)@ (tempY + taille))).
			((tableau at: col) at: lig) dragEnabled: false;openInWorld.
		]
	]! !

!MorphFire methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 6/13/2010 19:50'!
majColor
|ligne moy diss|

	diss := self dissipation.

	(1 to: tableau size -1) do:
	[:i|
		ligne := tableau at: i.
		"first case"
		moy := ((((tableau at:i+1) at: 1) color red)  + (((tableau at:i+1) at: 2)) color red)/3.
		moy := moy * diss.
		(ligne at: 1) color: (Color r:moy g:0 b:0).
		"last case"
		moy := ((((tableau at:i+1) at: ((tableau at:i+1) size) ) color red)  + (((tableau at:i+1) at: ((tableau at:i+1) size-1))) color red)/3.
		moy := moy * diss.
		(ligne at: (ligne size)) color: (Color r:moy g:0 b:0).
		
		(((ligne at:1) color red) = 0) &  (((ligne at:1) color blue) = 0) & (((ligne at:1) color green) = 0)
		ifTrue:[(ligne at:1) hide]
		ifFalse:[(ligne at:1)show].
		
		(((ligne at:(ligne size)) color red) = 0) &  (((ligne at:(ligne size)) color blue) = 0) & (((ligne at:(ligne size)) color green) = 0)
		ifTrue:[(ligne at:(ligne size)) hide]
		ifFalse:[(ligne at:(ligne size))show].
		
		(2 to: ligne size-1) do:
		[:j|
			moy := moy := ((((tableau at:i+1) at: j-1) color red)  + (((tableau at:i+1) at: j)) color red) + ((((tableau at:i+1) at: j+1)) color red)/3.
			moy := moy * diss.
			(ligne at: j) color: (Color r:moy g:0 b:0).
			(((ligne at:j) color red) = 0) &  (((ligne at:j) color blue) = 0) & (((ligne at:j) color green) = 0)
		ifTrue:[(ligne at:j) hide]
		ifFalse:[(ligne at:j)show].
		]
	]! !

!MorphFire methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 6/12/2010 19:41'!
majColor2
|ligne moy diss|

	diss := self dissipation.

	(2 to: tableau size -1) do:
	[:i|
		ligne := tableau at: i.
		"first case"
		moy := ((((tableau at:i+1) at: 1) color red)  + (((tableau at:i+1) at: 2) color red) + (((tableau at:i) at: 2) color red) + (((tableau at:i-1) at: 1) color red) + (((tableau at:i-1) at: 2) color red))/8.
		moy := moy * diss.
		(ligne at: 1) color: (Color r:moy g:0 b:0).
		"last case"
		moy := ((((tableau at:i+1) at: ((tableau at:i+1) size) ) color red)  + (((tableau at:i+1) at: ((tableau at:i+1) size-1) ) color red) + (((tableau at:i-1) at: ((tableau at:i-1) size) ) color red)+ (((tableau at:i-1) at: ((tableau at:i-1) size-1) + (((tableau at:i) at: ((tableau at:i) size-1) ) color red)) color red))/8.
		moy := moy * diss.
		(ligne at: (ligne size)) color: (Color r:moy g:0 b:0).
		
		
		(2 to: ligne size-1) do:
		[:j|
			moy := moy := (((((tableau at:i+1) at: j-1) color red)  + (((tableau at:i+1) at: j)) color red) + (((tableau at:i+1) at: j+1) color red) + (((tableau at:i) at: j-1) color red) + (((tableau at:i) at: j+1) color red) + (((tableau at:i-1) at: j-1) color red) + (((tableau at:i-1) at: j) color red)+ (((tableau at:i-1) at: j+1) color red))/8.
			moy := moy * diss.
			(ligne at: j) color: (Color r:moy g:0 b:0).
		]
	]! !

!MorphFire methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/12/2010 19:10'!
sleepTime
	^ sleepTime! !

!MorphFire methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/12/2010 19:10'!
sleepTime: anObject
	sleepTime := anObject! !

!MorphFire methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 6/13/2010 19:39'!
step
"|i|
	i isNil
	ifTrue: [i:=0] ifFalse: [i:=i+1]."
	self initColor.
	self majColor.
	self majColor2.
	"i > 50
	ifTrue:[self majColor2]."! !

!MorphFire methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 6/13/2010 15:51'!
stepTime
	^self sleepTime.! !

!MorphFire methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/12/2010 19:07'!
taille
	^ taille! !

!MorphFire methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/12/2010 19:07'!
taille: anObject
	taille := anObject! !

Object subclass: #STdoc
	instanceVariableNames: 'class stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Summer2010-STdoc'!

!STdoc commentStamp: 'BenjaminVanRyseghem 6/10/2010 15:23' prior: 0!
Un STdoc est un simili Javadoc.!

!STdoc classSide methodsFor: 'parsing' stamp: 'BenjaminVanRyseghem 6/10/2010 15:12'!
commentsFrom: aMethod
"Return the first comment of a method"

|source result boolWriting boolFirstComment start|
	source := aMethod getSource asString.
	result := ''.
	boolWriting := false.
	boolFirstComment := true.
	start := ((source lineNumber: 1) size +1).
	
	( start to: source size) do:
		[:i|
			(source at: i) = $"
				ifTrue: 
					[
						boolWriting 
							ifTrue: [boolWriting := false]	
							ifFalse: 
							[
								boolFirstComment 
									ifTrue: 
									[
										boolFirstComment := false.
										boolWriting := true.
									]						
							]
					]
				ifFalse: 
					[
						boolWriting
							ifTrue: [result := result, ((source at: i) asString)]
							ifFalse: 
							[
								(source at: i) isSeparator
								ifFalse:
								[
									boolFirstComment := false.
									
								]
							]
					]
		].
	^result withCRs.! !

!STdoc classSide methodsFor: 'parsing' stamp: 'BenjaminVanRyseghem 6/10/2010 15:19'!
nameOf: aMethod
"Return the name of method"

|source result boolWriting|
	source := (aMethod name subStrings: '>>' ) at: 2.
	result := ''.
	boolWriting := true.
	
	(1 to: source size-1) do:
		[:i|
			((source at: i+1) asString ) = ''
				ifTrue: [boolWriting := false]
				ifFalse: 
				[
					boolWriting 
						ifTrue: [result := result, ((source at: i) asString)] 
						ifFalse: []
				]
		
		].
	^result.! !

!STdoc methodsFor: 'generating' stamp: 'BenjaminVanRyseghem 6/13/2010 15:38'!
build

	self displayHeader.
	self displayInstanceVariables.
	self displayClassVariables.
	self displayInstanceMethods.
	self displayClassMethods. 
	self displaySuperClass. 
	self displaySubClasses.
	^self stream contents! !

!STdoc methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/10/2010 15:09'!
classMethods
	^self myclass class methods.! !

!STdoc methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/10/2010 15:37'!
classVariables
	^self myclass classVarNames.! !

!STdoc methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/10/2010 15:15'!
comment

	^self myclass class comment.! !

!STdoc methodsFor: 'display' stamp: 'BenjaminVanRyseghem 6/13/2010 15:36'!
displayClassMethods

	self classMethods size = 0
	ifFalse:
	[
		self stream nextPutAll: '----------------------------------------------';cr.
		self stream nextPutAll: 'Mthodes d''instance :';cr.
		self classMethods do:
		[:each|
			self stream nextPutAll:'     '; nextPutAll:(STdoc nameOf: each);cr.
			(STdoc commentsFrom: each) = ''
			ifTrue: 
			[
				self stream nextPutAll: '     '; nextPutAll:('Just another uncommented method');cr;cr.
			] 
			ifFalse: 
			[
				self stream nextPutAll: '     '; nextPutAll:(STdoc commentsFrom: each);cr;cr.
			].
			
		]
	].! !

!STdoc methodsFor: 'display' stamp: 'BenjaminVanRyseghem 6/13/2010 15:36'!
displayClassVariables
	
	self classVariables size = 0
	ifFalse:
	[
		self stream nextPutAll: '----------------------------------------------';cr.
		self stream nextPutAll: 'Variables de classe :'; cr.
		self classVariables do:
		[:each|
			self stream nextPutAll: '     '; nextPutAll: each; cr.
		].
	].! !

!STdoc methodsFor: 'display' stamp: 'BenjaminVanRyseghem 6/13/2010 15:37'!
displayHeader
		self stream nextPutAll: self name; cr.
		self stream nextPutAll: self comment;cr;cr.! !

!STdoc methodsFor: 'display' stamp: 'BenjaminVanRyseghem 6/13/2010 15:36'!
displayInstanceMethods

	self instanceMethods size = 0
	ifFalse:
	[
		self stream nextPutAll: '----------------------------------------------'; cr.
		self stream nextPutAll: 'Mthodes d''instance :'; cr.
		self instanceMethods do:
		[:each|
			self stream nextPutAll: '     '; nextPutAll:(STdoc nameOf: each); cr.
			(STdoc commentsFrom: each) = ''
			ifTrue: 
			[
				self stream nextPutAll: '     '; nextPutAll:('Just another uncommented method');cr;cr.
			] 
			ifFalse: 
			[
				self stream nextPutAll: '     '; nextPutAll:(STdoc commentsFrom: each);cr;cr.
			].
			
		]
	].! !

!STdoc methodsFor: 'display' stamp: 'BenjaminVanRyseghem 6/13/2010 15:36'!
displayInstanceVariables
	
	self instanceVariables size = 0
	ifFalse:
	[
		self stream nextPutAll: '----------------------------------------------'; cr.
		self stream nextPutAll: 'Variables d''instance :';cr.
		self instanceVariables do:
		[:each|
			self stream nextPutAll: '     '; nextPutAll: each; cr.
		].
	].
! !

!STdoc methodsFor: 'display' stamp: 'BenjaminVanRyseghem 6/13/2010 15:36'!
displaySubClasses
	
	self subClasses size = 0
	ifFalse:
	[
		self stream nextPutAll: '----------------------------------------------'; cr.
		self stream nextPutAll: 'SubClasses :'; cr.
		"self subClasses do:
		[:each|
			result := result, '     ',each name, String cr.
			result := result, '     ',('Afficher la doc: (STdoc new with: ',each name,';build)'), String cr, String cr.
		]."
		
	].! !

!STdoc methodsFor: 'display' stamp: 'BenjaminVanRyseghem 6/13/2010 15:36'!
displaySuperClass
	
	self superClass isNil
	ifFalse:
	[
		self stream nextPutAll: '----------------------------------------------'; cr.
		self stream nextPutAll: 'Superclass :'; cr.
		self stream nextPutAll: '     '; nextPutAll: (self superClass name); cr.
		"result := result, '     ',('Afficher la doc: (STdoc new with: ',self superClass name,';build)'), String cr, String cr."
	].! !

!STdoc methodsFor: 'generating' stamp: 'BenjaminVanRyseghem 6/11/2010 16:18'!
export

	self export: ((self name),'.txt').! !

!STdoc methodsFor: 'generating' stamp: 'BenjaminVanRyseghem 6/11/2010 16:17'!
export: aString
	|temp|
	temp := self build.
	StandardFileStream 
	fileNamed: aString
	do:[:str|str nextPutAll: temp.]! !

!STdoc methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/13/2010 15:35'!
initialize

stream := WriteStream on: String new.! !

!STdoc methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/10/2010 15:22'!
instanceMethods
	^self myclass methodDict values.! !

!STdoc methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/10/2010 15:09'!
instanceVariables
	^self myclass instVarNames.! !

!STdoc methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/10/2010 15:06'!
myclass
	^ class
! !

!STdoc methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/10/2010 15:25'!
myclass: anObject
"Setter"
	class := anObject! !

!STdoc methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/10/2010 15:13'!
name

	^self myclass name.! !

!STdoc methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/13/2010 15:34'!
stream
	^ stream! !

!STdoc methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/13/2010 15:34'!
stream: anObject
	stream := anObject! !

!STdoc methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/10/2010 15:10'!
subClasses
	^self myclass subclasses.! !

!STdoc methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/10/2010 15:10'!
superClass
	^self myclass superclass.! !

!STdoc methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/10/2010 15:04'!
with: aClass 

class := aClass .! !
